using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

// TriggerUI 1.0 Plugin by CaptainVarghoss
// The purpose of this plugin is to allow a scene UI button (or other trigger) to open UI elements such as the clothing tab, morphs tab, etc.
// Special thanks to Everlaster and God for a little help.

namespace CaptainVarghoss {
	public class TriggerUI : MVRScript {
		
		protected JSONStorableAction triggerUIClothes;
		protected JSONStorableAction triggerUIClothesPreset;
		protected JSONStorableAction triggerUIHair;
		protected JSONStorableAction triggerUIHairPreset;
		protected JSONStorableAction triggerUIMaleMorphs;
		protected JSONStorableAction triggerUIFemaleMorphs;
		protected JSONStorableAction triggerUIMorphsPresets;
		protected JSONStorableAction triggerUIMouthMaterials;
		protected JSONStorableAction triggerUITongueMaterials;
		protected JSONStorableAction triggerUITeethMaterials;
		protected JSONStorableAction triggerUIMEyelashMaterials;
		protected JSONStorableAction triggerUIFEyelashMaterials;
		protected JSONStorableAction triggerUILacrimalsMaterials;
		protected JSONStorableAction triggerUIScleraMaterials;
		protected JSONStorableAction triggerUIIrisMaterials;
		protected JSONStorableAction triggerUISkinTextures;
		protected JSONStorableAction triggerUISkinMaterials2;
		protected JSONStorableAction triggerUISkinMaterials1;
		protected JSONStorableAction triggerUISkinSelect;
		protected JSONStorableAction triggerUISkinPresets;
		protected JSONStorableAction triggerUIHandControl;
		protected JSONStorableAction triggerUIHeadAudio;
		protected JSONStorableAction triggerUIPlugins;
		protected JSONStorableAction triggerUIPluginsPresets;
		protected JSONStorableAction triggerUIAutoBehaviours;
		protected JSONStorableAction triggerUIJawPhysics;
		protected JSONStorableAction triggerUIMPectoralPhysics;
		protected JSONStorableAction triggerUIFBreastPhysics2;
		protected JSONStorableAction triggerUIFBreastPhysics1;
		protected JSONStorableAction triggerUIFBreastPresets;
		protected JSONStorableAction triggerUIFGlutePhysics;
		protected JSONStorableAction triggerUIFGlutePresets;
		protected JSONStorableAction triggerUIAnimation;
		protected JSONStorableAction triggerUIAnimationPresets;
		protected JSONStorableAction triggerUIMove;
		protected JSONStorableAction triggerUIPosePresets;
		protected JSONStorableAction triggerUIAppearancePreset;
		protected JSONStorableAction triggerUIGeneralPresets;
		protected JSONStorableAction triggerUIControlPhysics2;
		protected JSONStorableAction triggerUIControlPhysics1;
		
		
		private static Atom currentAtom;
		private static string t = "None";
		
		public override void Init() {
			try {
				currentAtom = containingAtom;

				triggerUIClothes = new JSONStorableAction("Clothing Tab", () => DoTrigger("Clothing"));
				triggerUIClothesPreset = new JSONStorableAction("Clothing Presets Tab", () => DoTrigger("Clothing Presets"));
				triggerUIHair = new JSONStorableAction("Hair Tab", () => DoTrigger("Hair"));
				triggerUIHairPreset = new JSONStorableAction("Hair Presets Tab", () => DoTrigger("Hair Presets"));
				triggerUIMaleMorphs = new JSONStorableAction("Male Morphs Tab", () => DoTrigger("Male Morphs"));
				triggerUIFemaleMorphs = new JSONStorableAction("Female Morphs Tab", () => DoTrigger("Female Morphs"));
				triggerUIMorphsPresets = new JSONStorableAction("Morphs Presets Tab", () => DoTrigger("Morphs Presets"));
				triggerUIMouthMaterials = new JSONStorableAction("Mouth Materials Tab", () => DoTrigger("Mouth Materials"));
				triggerUITongueMaterials = new JSONStorableAction("Tongue Materials Tab", () => DoTrigger("Tongue Materials"));
				triggerUITeethMaterials = new JSONStorableAction("Teeth Materials Tab", () => DoTrigger("Teeth Materials"));
				triggerUIMEyelashMaterials = new JSONStorableAction("M Eyelash Materials Tab", () => DoTrigger("M Eyelash Materials"));
				triggerUIFEyelashMaterials = new JSONStorableAction("F Eyelash Materials Tab", () => DoTrigger("F Eyelash Materials"));
				triggerUILacrimalsMaterials = new JSONStorableAction("Lacrimals Materials Tab", () => DoTrigger("Lacrimals Materials"));
				triggerUIScleraMaterials = new JSONStorableAction("Sclera Materials Tab", () => DoTrigger("Sclera Materials"));
				triggerUIIrisMaterials = new JSONStorableAction("Iris Materials Tab", () => DoTrigger("Iris Materials"));
				triggerUISkinTextures = new JSONStorableAction("Skin Textures Tab", () => DoTrigger("Skin Textures"));
				triggerUISkinMaterials2 = new JSONStorableAction("Skin Materials 2 Tab", () => DoTrigger("Skin Materials 2"));
				triggerUISkinMaterials1 = new JSONStorableAction("Skin Materials 1 Tab", () => DoTrigger("Skin Materials 1"));
				triggerUISkinSelect = new JSONStorableAction("Skin Select Tab", () => DoTrigger("Skin Select"));
				triggerUISkinPresets = new JSONStorableAction("Skin Presets Tab", () => DoTrigger("Skin Presets"));
				triggerUIHandControl = new JSONStorableAction("Hand Control Tab", () => DoTrigger("Hand Control"));
				triggerUIHeadAudio = new JSONStorableAction("Head Audio Tab", () => DoTrigger("Head Audio"));
				triggerUIPlugins = new JSONStorableAction("Plugins Tab", () => DoTrigger("Plugins"));
				triggerUIPluginsPresets = new JSONStorableAction("Plugins Presets Tab", () => DoTrigger("Plugins Presets"));
				triggerUIAutoBehaviours = new JSONStorableAction("Auto Behaviours Tab", () => DoTrigger("Auto Behaviours"));
				triggerUIJawPhysics = new JSONStorableAction("Jaw Physics & Triggers Tab", () => DoTrigger("Jaw Physics & Triggers"));
				triggerUIMPectoralPhysics = new JSONStorableAction("M Pectoral Physics Tab", () => DoTrigger("M Pectoral Physics"));
				triggerUIFBreastPhysics2 = new JSONStorableAction("F Breast Physics 2 Tab", () => DoTrigger("F Breast Physics 2"));
				triggerUIFBreastPhysics1 = new JSONStorableAction("F Breast Physics 1 Tab", () => DoTrigger("F Breast Physics 1"));
				triggerUIFBreastPresets = new JSONStorableAction("F Breast Presets Tab", () => DoTrigger("F Breast Presets"));
				triggerUIFGlutePhysics = new JSONStorableAction("F Glute Physics Tab", () => DoTrigger("F Glute Physics"));
				triggerUIFGlutePresets = new JSONStorableAction("F Glute Presets Tab", () => DoTrigger("F Glute Presets"));
				triggerUIAnimation = new JSONStorableAction("Animation Tab", () => DoTrigger("Animation"));
				triggerUIAnimationPresets = new JSONStorableAction("Animation Presets Tab", () => DoTrigger("Animation Presets"));
				triggerUIMove = new JSONStorableAction("Move Tab", () => DoTrigger("Move"));
				triggerUIPosePresets = new JSONStorableAction("Pose Presets Tab", () => DoTrigger("Pose Presets"));
				triggerUIAppearancePreset = new JSONStorableAction("Appearance Presets Tab", () => DoTrigger("Appearance Presets"));
				triggerUIGeneralPresets = new JSONStorableAction("General Presets Tab", () => DoTrigger("General Presets"));
				triggerUIControlPhysics2 = new JSONStorableAction("Control & Physics 2 Tab", () => DoTrigger("Control & Physics 2"));
				triggerUIControlPhysics1 = new JSONStorableAction("Control & Physics 1 Tab", () => DoTrigger("Control & Physics 1"));
				
				RegisterAction(triggerUIClothes);
				RegisterAction(triggerUIClothesPreset);
				RegisterAction(triggerUIHair);
				RegisterAction(triggerUIHairPreset);
				RegisterAction(triggerUIMaleMorphs);
				RegisterAction(triggerUIFemaleMorphs);
				RegisterAction(triggerUIMorphsPresets);
				RegisterAction(triggerUIMouthMaterials);
				RegisterAction(triggerUITongueMaterials);
				RegisterAction(triggerUITeethMaterials);
				RegisterAction(triggerUIMEyelashMaterials);
				RegisterAction(triggerUIFEyelashMaterials);
				RegisterAction(triggerUILacrimalsMaterials);
				RegisterAction(triggerUIScleraMaterials);
				RegisterAction(triggerUIIrisMaterials);
				RegisterAction(triggerUISkinTextures);
				RegisterAction(triggerUISkinMaterials2);
				RegisterAction(triggerUISkinMaterials1);
				RegisterAction(triggerUISkinSelect);
				RegisterAction(triggerUISkinPresets);
				RegisterAction(triggerUIHandControl);
				RegisterAction(triggerUIHeadAudio);
				RegisterAction(triggerUIPlugins);
				RegisterAction(triggerUIPluginsPresets);
				RegisterAction(triggerUIAutoBehaviours);
				RegisterAction(triggerUIJawPhysics);
				RegisterAction(triggerUIMPectoralPhysics);
				RegisterAction(triggerUIFBreastPhysics2);
				RegisterAction(triggerUIFBreastPhysics1);
				RegisterAction(triggerUIFBreastPresets);
				RegisterAction(triggerUIFGlutePhysics);
				RegisterAction(triggerUIFGlutePresets);
				RegisterAction(triggerUIAnimation);
				RegisterAction(triggerUIAnimationPresets);
				RegisterAction(triggerUIMove);
				RegisterAction(triggerUIPosePresets);
				RegisterAction(triggerUIAppearancePreset);
				RegisterAction(triggerUIGeneralPresets);
				RegisterAction(triggerUIControlPhysics2);
				RegisterAction(triggerUIControlPhysics1);


				SuperController.LogMessage("TriggerUI Loaded");

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void DoTrigger(string id) {
//			SuperController.LogMessage("Setting Tab 1: " + id + " for " + currentAtom.name);
			var sc = SuperController.singleton;
			// Set game mode to edit (doesn't work in play mode)
			sc.gameMode = SuperController.GameMode.Edit;
			// Select the atom's main control
			sc.SelectController(currentAtom.mainController);
			// Select which UI to show
			sc.activeUI = SuperController.ActiveUI.SelectedOptions;
			// Open the UI
			sc.ShowMainHUDAuto();
			//  This will open whatever tab was opened last
			var selector = currentAtom.gameObject.GetComponentInChildren<UITabSelector>(true);
//			SuperController.LogMessage("Setting Tab 2: " + id);
			selector.SetActiveTab(id); // or Plugins, etc.

		}
		
		// Update is called with each rendered frame by Unity
		void Update() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// FixedUpdate is called with each physics simulation frame by Unity
		void FixedUpdate() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// OnDestroy is where you should put any cleanup
		// if you registered objects to supercontroller or atom, you should unregister them here
		void OnDestroy() {
		}

	}
}